--[[ topChat ]]--
local tcVersion = "7"

--
-- ***** edit to your liking... *****
--

local topEnable = true			-- move edit bar to top of chatframe?
local stickyEnable = true		-- enable un/sticky channel list?
local mouseEnable = true			-- enable the mousewheel to scroll?
local timestampEnable = true		-- timestamp the incoming messages?
local spamblockEnable = true		-- block repeated message text? (timestamp needs to be on as well)

-- SAY, YELL, EMOTE, PARTY, RAID, GUILD, OFFICER, WHISPER, CHANNEL, SYSTEM
-- CHANNEL refers to all numbered channels
local stickyList = {"OFFICER","CHANNEL"}	-- sticky channel list
local unstickyList = {}					-- unsticky channel list

local mouseScrollNum = 2			-- how many lines do you wanna scroll w/ mousewheel?

local timestampFormat = "%H:%M"	-- timestamp display format
local timestampLeft = "{"		-- timestamp left bracket
local timestampRight = "} "		-- timestamp right bracket

--
-- ***** keep your mitts off below... =) *****
--

local tcPreviousChat = ""
function DEFAULT_CHAT_FRAME.tc_AddMessage(self,text,red,green,blue,alpha,hold)
  if(text) then
    if(spamblockEnable) then if(tcPreviousChat==text) then return else tcPreviousChat=text end end
    DEFAULT_CHAT_FRAME.tc_OldAddMessage(self,timestampLeft..date(timestampFormat)..timestampRight..text,red,green,blue,alpha,hold)
  else
    DEFAULT_CHAT_FRAME.tc_OldAddMessage(self,text,red,green,blue,alpha,hold)
  end
end

function tc_ChatScroll(x)
  if(x) then
    if(x > 0) then
      for i=1,mouseScrollNum do this:ScrollUp() end
    else
      for i=1,mouseScrollNum do this:ScrollDown() end
    end
  end
end

if(topEnable) then
  ChatFrameEditBox:ClearAllPoints()
  ChatFrameEditBox:SetPoint("BOTTOMLEFT", ChatFrame1, "TOPLEFT")
  ChatFrameEditBox:SetPoint("BOTTOMRIGHT", ChatFrame1, "TOPRIGHT")
end

if(stickyEnable) then
  for _,z in pairs(stickyList) do
    ChatTypeInfo[z].sticky = 1
  end
  for _,z in pairs(unstickyList) do
    ChatTypeInfo[z].sticky = nil
  end
end

if(mouseEnable) then
  for i=1,9 do
    local x = getglobal("ChatFrame"..i)
    if(x) then
      x:EnableMouseWheel(true)
      x:SetScript("OnMouseWheel", function() tc_ChatScroll(arg1) end)
    end
  end
end

if(timestampEnable) then
  DEFAULT_CHAT_FRAME.tc_OldAddMessage = DEFAULT_CHAT_FRAME.AddMessage
  DEFAULT_CHAT_FRAME.AddMessage = DEFAULT_CHAT_FRAME.tc_AddMessage
end

if(ChatFrame2) then
  ChatFrame2:AddMessage(":: topChat version "..tcVersion.." loaded ::",0,0.8,1.0)
end
